// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <Windows.h>
#include <winternl.h>
#include <ntstatus.h>

#pragma comment(lib, "Ntdll.lib")

void TestLocalAlloc()
{
    int length = 0x1000;

    printf("GlobalAlloc Test...\n");

    // LPVOID pVoid = ::GlobalAlloc(0, length);
    LPVOID pVoid = ::HeapAlloc(GetProcessHeap(), 0, length);

    printf("value on 0x%I64x\n", *(__int64 *)pVoid);

    ULONG returnLength = 0;
    NTSTATUS ntResult = NtQuerySystemInformation((SYSTEM_INFORMATION_CLASS)16, (LPVOID)pVoid, length, &returnLength);
    if (ntResult == STATUS_INFO_LENGTH_MISMATCH)
    {
        // Round required memory up to the nearest 64KB boundary. 
        length = ((returnLength + 0xffff) & ~0xffff);
        printf("returnLength: %d(0x%x), length: %d(0x%x)\n", returnLength, returnLength, length, length);
    }

    ::GlobalFree(pVoid);

    // pVoid = ::GlobalAlloc(0, length);
    pVoid = ::HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, length);
    printf("ptr == 0x%I64x\n", pVoid);
    printf("value on 0x%I64x\n", *(__int64 *)pVoid);

    //BYTE *pBytes = (BYTE *)pVoid;
    //for (int i = 0; i < length; i++)
    //{
    //    *(pBytes + i) = 0x60;
    //}

    //bool allZero = true;
    //BYTE *pBytes = (BYTE *)pVoid;
    //for (int i = 0; i < length; i++)
    //{
    //    if (*(pBytes) != 0)
    //    {
    //        allZero = false;
    //        break;
    //    }
    //}

    // printf("AllZero == %s\n", (allZero == true) ? "true" : "false");

    memset(pVoid, 0, length);

    ntResult = NtQuerySystemInformation((SYSTEM_INFORMATION_CLASS)16, (LPVOID)pVoid, length, &returnLength);
    if (ntResult == STATUS_SUCCESS)
    {
        __int64 *lResult = (__int64 *)pVoid;
        printf("%I64d\n", *lResult);
    }
    else
    {
        printf("ntquery failed: %d\n", ntResult);
    }
}

int main()
{
    TestLocalAlloc();
    return 0;
}

